# -*- tcl -*-
#		Pool 2.2, as of February 20, 1999
#		Pool_Net @net:mFullVersion@
#
# CVS: $Id: port.tcl,v 1.2 1998/06/01 19:56:38 aku Exp $
#
# @c Definition of port to use by pop3 client and server cores.
# @c Might be overidden for testing purposes.
# @s Definition of port to use by pop3 client and server cores.
# @i POP3, port definition for POP3
# -----------------------------

package require Tcl 8.0

# Create the required namespaces before adding information to them.
# Initialize some info variables.

namespace eval ::pool {
    variable version 2.2
    variable asOf    February 20, 1999

    namespace eval pop3 {
	variable version @base:mFullVersion@
	namespace export *
    }
}


proc ::pool::pop3::port {} {
    # @c This command returns the port to be used by clients
    # @c (<f net/pop3/pop3.cls>. Its redefinition allows usage
    # @c of a different port for testing purposes; and is
    # @c simpler than the implementation of a -port option.

    return pop3
}

